/*
TASK:lines
LANG:C++
*/

#include <cstdio>
#include <algorithm>

using namespace std;

int sx[320000] = { 0 }, sy[320000] = { 0 }, ex[320000] = { 0 }, ey[320000] = { 0 };
int x1, x2, y1, y2, e = 0;
int n;

int checkx();
int checky();

int main()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d %d %d %d", &x1, &y1, &x2, &y2);
		if (x1 <= x2)
		{
			sx[e] = x1;
			ex[e] = x2;
		}
		else
		{
			sx[e] = x2;
			ex[e] = x1;
		}
		if (y1 <= y2)
		{
			sy[e] = y1;
			ey[e] = y2;
		}
		else
		{
			sy[e] = y2;
			ey[e] = y1;
		}
		e++;
	}
	sort(sx, sx + n);
	sort(sy, sy + n);
	sort(ex, ex + n);
	sort(ey, ey + n);
	int m = checkx();
	int l = checky();
	printf("%d\n", m > l ? m : l);
	return 0;
}

int checkx()
{
	int i, j, k = 0, x = 0;
	for (i = 0, j = 0; i + j < 2 * n;)
	{
		if ((i != n && sx[i] <= ex[j]) || j == n)
		{
			k++;
			if (x < k) x = k;
			i++;
		}
		else
		{
			k--;
			j++;
		}
	}
	return x;
}

int checky()
{
	int i, j, k = 0, y = 0;
	for (i = 0, j = 0; i + j < 2 * n;)
	{
		if ((i != n && sy[i] <= ey[j]) || j == n)
		{
			k++;
			if (y < k) y = k;
			i++;
		}
		else
		{
			k--;
			j++;
		}
	}
	return y;
}
