/*
TASK:rings
LANG:C++
*/


#include <iostream>
#include <cstdio>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
using namespace std;

#define pb(x) push_back(x)
#define rep(i,n) for(i=0;i<n;i++)
#define MAXN 1024
#define pii pair<int,int>
#define vactor vector

vector<int> a[MAXN];
int N,M;
int A,B;
int pc[MAXN];
int pc2[MAXN];
int mini=1000000;
bool cor1[MAXN];
bool cor2[MAXN];
bool used[MAXN];
bool used2[MAXN];

void fDFS(int c,int l) {
     int i;
     used[c]=true;
     if (pc[c]>l) pc[c]=l;
     if (c==B) {
        if (l<=mini) {
           mini=l;
           pc[c]=mini;
           }
        }
     else {
          rep (i,a[c].size()) {
              if (used[a[c][i]]==true && pc[a[c][i]]<l+1 ) continue;
              fDFS(a[c][i],l+1);
              }
     }
}

void rDFS(int c) {
     int i;
     cor1[c]=true;
     rep (i,a[c].size()) 
         if (pc[a[c][i]]==pc[c]-1) 
            rDFS(a[c][i]);
}

void fDFS2(int c,int l) {
     int i;
     used2[c]=true;
     if (pc2[c]>l) pc2[c]=l;
     if (c==B) {
        if (l<=mini) {
           mini=l;
           pc2[c]=mini;
           }
        }
     else {
          rep (i,a[c].size()) {
              if (used2[a[c][i]]==true && pc2[a[c][i]]<l+1 ) continue;
              fDFS2(a[c][i],l+1);
              }
     }
}

void rDFS2(int c) {
     int i;
     cor2[c]=true;
     rep (i,a[c].size()) 
         if (pc2[a[c][i]]==pc2[c]-1) 
            rDFS2(a[c][i]);
}
                        
     

int main() {
    scanf("%d%d",&N,&M);
    int i,k;
    int br1=0,br2=0;
    rep (i,M) {
        int e,f;
        scanf("%d%d",&e,&f);
        e--;
        f--;
        a[e].pb(f);
        a[f].pb(e);
        }
    rep(i,N) pc[i]=1000000;
    scanf("%d%d",&A,&B);
    A--;
    B--;
    fDFS(A,0);
    rDFS(B);
    rep(i,N)
            if (cor1[i]==false) br1++;
    mini=1000000;
    rep(i,N) pc2[i]=1000000;
    scanf("%d%d",&A,&B);
    A--;
    B--;
    fDFS2(A,0);
    rDFS2(B);
    rep(i,N)
            if (cor2[i]==false) br2++;
    printf("%d %d\n",br1,br2);
return 0;
}
 
