/*
TASK:lines
LANG:C++
*/
#include <iostream>
#include <algorithm>
using namespace std;

struct lines{
       int x1, x2, y1, y2;
} line[300000], liney[300000];

void swapp (lines &p1, lines &p2)
{
     swap(p1.x1, p2.x1);
     swap(p1.x2, p2.x2);
     swap(p1.y1, p2.y1);
     swap(p1.y2, p2.y2);
}
void qs(int l, int r)
{
     int i = l, j = r, x = line[r].x1;
     do{
         while(line[i].x1 < x) i++;
         while(line[j].x1 > x) j--;
         if(i <= j) swapp(line[i], line[j]), i++, j--;
         }
     while(i <= j);
     if(l < j) qs(l, j);
     if(i < r) qs(i, r);
}
void qs2(int l, int r)
{
     int i = l, j = r, x = liney[r].y1;
     do{
         while(liney[i].y1 < x) i++;
         while(liney[j].y1 > x) j--;
         if(i <= j) swapp(liney[i], liney[j]), i++, j--;
         }
     while(i <= j);
     if(l < j) qs(l, j);
     if(i < r) qs(i, r);
}
void solve(int n)
{
     int start, end, maxx = 0, maxy = 0, cnt, j;
     for(int i = 0; i < n; i++)
     {
             cnt = 1, j = i;
             start = line[i].x1, end = line[i].x2;
             while((line[j + 1].x1 >= start && line[j + 1].x1 <= end) ||
                   (line[j + 1].x2 >= start && line[j + 1].x2 <= end))
             {
                   start = max(line[j].x1, line[j + 1].x1);
                   end = min(line[j].x2, line[j + 1].x2);
                   cnt++, j++;
             }
             if(maxx < cnt) maxx = cnt;
     }
     for(int i = 0; i < n; i++)
     {
             cnt = 1, j = i;
             start = liney[i].y1, end = liney[i].y2;
             while((liney[j + 1].y1 >= start && liney[j + 1].y1 <= end) ||
                   (liney[j + 1].y2 >= start && liney[j + 1].y2 <= end))
             {
                   start = max(liney[j].y1, liney[j + 1].y1);
                   end = min(liney[j].y2, liney[j + 1].y2);
                   cnt++, j++;
             }
             if(maxy < cnt) maxy = cnt;
     }
     
     cout << max(maxx, maxy) << endl;
}
                   
                             
int main ()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> line[i].x1 >> line[i].y1 >> line[i].x2 >> line[i].y2;
        if(line[i].x1 > line[i].x2) 
                      swap(line[i].x1, line[i].x2), swap(line[i].y1, line[i].y2);
        liney[i].x1 = line[i].x1; liney[i].x2 = line[i].x2;
        liney[i].y1 = line[i].y1; liney[i].y1 = line[i].y2;
        if(liney[i].y1 > liney[i].y2) 
                       swap(liney[i].y1, liney[i].y2), swap(liney[i].y1, liney[i].y2);
    }  
    qs(0, n - 1);
    qs2(0, n - 1);   
    solve(n);
    cin >> n;
    return 0;
}
