/*
LANG : C++
task : rings
*/
#include <iostream.h>
#include <fstream.h>

using namespace std;

int a[1000][1000], M, N, min_len, len=1, T;

    int queue[1000], oper[1000];
    bool used[1000];
  //  ofstream out ("rings.0.out");
  //  ifstream in ("rings.0.in");
    

void clear()
{
        for (int j=0; j<N; j++)
            used[j] = false;
}

int BFS (int start, int E, bool min)
{
    clear();
    for (int j=0; j<N; j++)
        queue[j] = -1;
    oper[start] = 2;
    oper[E] = 2;
    queue[0] = start;
    used[start] = true;
    int level = 1, end = 1, current = 0, i;
    while (current < end)
      {
        for (;current < level; current++)
          {
            for (int s=0; s<N; s++)
                if (a[s][queue[current]] && !used[s])
                  {
                    if (s == E)
                        return len+1;
                    used[s] = true;
                    if (oper[queue[current]] && min == false)
                        oper[s]++;
                    queue[end++] = s;
                  }
          }
        level = end;
        len++;
      }
}

void count()
{
     int br=0;
     for (int i=0; i<N; i++)
         if (oper[i] > 1)
             br++;
    cout << N-br;
}

int main ()
{
    int i, j, x, y, A, B;
    cin >> N >> M;
    for (i=0; i<M; i++)
      {
        cin >> x >> y;
        a[x-1][y-1] = 1;
        a[y-1][x-1] = 1;
      }
    for (T=0; T<2; T++)
      {
        cin >> A >> B;
        for (int k=0; k<N; k++)
            oper[k] = 0;
        min_len = BFS(A-1, B-1, true);
        BFS(A-1, B-1, false);
        BFS(B-1, A-1, false);
        count();if (T==0) cout << " "; else cout << "\n";
      }
cin >> N;
return 0;
}
