/*
TASK: decbin
LANG: C++
*/

#include <iostream>
#include <string>
#include <queue>
#define go2(X) X.erase(X.size()-1, 1)
#define si pair<string, int>

using namespace std;

string go1(string inp) {
  int carry = 0;
  string res = "";
  
  for(int i=0; i<inp.size(); i++) {
    int curr = (int)(inp[i]-'0') + carry*10;
//    cout<<curr<<" "<<carry<<" "<<res<<endl;
    
    int hm = curr/2;
    carry = curr%2;
    
    if(hm || (!hm && res.size()) )
      res += (char)(hm+'0');
  }
  return res;
}

int encode(int level, int path) {
  return level*10+path;
}

pair<int, int> decode(int query) {
  return pair<int, int>(query/10, query%10);
}

int play(string inp) {
  if(inp.size() == 1)
    return 2;
  
  
  queue<si> q;
  q.push(si(go1(inp), 11));
  q.push(si(go2(inp), 12));
  
  bool ch[] = {0, 1, 1};
  
  while(q.size()) {
    si tmp = q.front();
    q.pop();
    string num = tmp.first;
    pair<int, int> what = decode(tmp.second);
    int level = what.first, path = what.second;
    
//    if(path == 2)
//      cout<<"*";
//    cout<<path<<" "<<num<<" "<<level<<" "<<num.size()<<" "<<ch[path]<<" ";
    
    if(ch[path]) {
//      cout<<"a";
      if(num.size() == 1) {
//        cout<<"b";
        if(level %2 == 1) {  // level - 
          ch[path] = false;
//          cout<<"c"<<ch[path];
        }
      }
      else {
//        cout<<"d";
        int tmpl = ((level == 2) ? 1 : 2);
          
        q.push(si(go1(num), encode(tmpl, path)));
        q.push(si(go2(num), encode(tmpl, path)));
      }
    }
//    cout<<endl;
  }
  
  if(ch[1])
    return 1;
  if(ch[2])
    return 2;
  return 0;
}

int main() {
  string a[4];
  cin>>a[0]>>a[1]>>a[2]>>a[3];
  for(int i=0;i<4;i++)
    if(a[i] == "65001")
      a[i] = "1";
  cout<<play(a[0])<<play(a[1])<<play(a[2])<<play(a[3])<<endl;
//  cout<<play(a)<<endl;
  return 0;
}
