/*
TASK:rings
LANG:C++
*/

#include <iostream>
#include <queue>
using namespace std;

//struct node
//{
//    int v, l;
//    int par;
//};

int n, m;
int a[1024][1024];
bool visit[1024], sol[1024];
int le[1024], d[1024];
int A, B;
int len;

void BFS2( int v )
{
    queue<int> q;
    q.push( v );
    int i, j, u, k;
    visit[v] = 1;
    while ( !q.empty() )
    {
        u = q.front();
        q.pop();
        for ( i = 1; i <= a[u][0]; i++ )
        {
            j = a[u][i];
            if ( visit[j] == 0 )
            {
                visit[j] = 1;
                d[j] = d[u] + 1;
                q.push( j );
            }
        }
    }
}

void BFS( int v, int v1 )
{
    queue<int> q;
    le[v] = 0;
    q.push( v );
    int i, j, u, l = 0;
    int k, x;
    
    visit[v] = 1;
    while ( !q.empty() )
    {
        u = q.front();
        q.pop();
        for ( i = 1; i <= a[u][0]; i++ )
        {
            j = a[u][i];
            if ( visit[j] == 0 )
            {
                visit[j] = 1;
                le[j] = le[u] + 1;
                q.push( j );
                if ( j == v1 )
                {
                    len = le[j];
                }
            }
        }
    }
    return;
}

int main()
{
    int i, j;
    int s, t;

    cin >> n >> m;
    
    for ( i = 1; i <= n; i++ )
    {
        sol[i] = 0;
        a[i][0] = 0;
    }
    for ( i = 1; i <= m; i++ )
    {
        cin >> s >> t;
        a[s][++a[s][0]] = t;
        a[t][++a[t][0]] = s;
    }
    cin >> A >> B;

    for ( i = 1; i <= n; i++ )
        visit[i] = 0;
    BFS( A, B );
    for ( i = 1; i <= n; i++ )
        visit[i] = 0;
    BFS2( B );
    s = 0;
    for ( i = 1; i <= n; i++ )
    {
        if ( d[i] + le[i] != len )
        {
            s++;
        }
    }
    cout << s << " ";

    cin >> A >> B;
    for ( i = 1; i <= n; i++ )
    {
        sol[i] = 0;
        d[i] = 0;
        le[i] = 0;
    }
    for ( i = 1; i <= n; i++ )
        visit[i] = 0;
    BFS( A, B );
    for ( i = 1; i <= n; i++ )
        visit[i] = 0;
    BFS2( B );
    s = 0;
    for ( i = 1; i <= n; i++ )
    {
        if ( d[i] + le[i] != len )
          s++;
    }
    cout << s << endl;
    return 0;
}
